import { isAsyncIterable } from './utils/iterator.js';
export function concat(...data) {
    if (data.some(isAsyncIterable) || data.some(datum => datum instanceof Promise)) {
        return {
            async *[Symbol.asyncIterator]() {
                for await (let datum of await Promise.all(data))
                    yield* datum;
            },
        };
    }
    return {
        *[Symbol.iterator]() {
            for (let datum of data)
                yield* datum;
        },
    };
}
