import { isAsyncIterable } from './utils/iterator.js';
export function find(predicate) {
    return function findFn(data) {
        if (isAsyncIterable(data) || data instanceof Promise) {
            return (async () => {
                let stream = data instanceof Promise ? await data : data;
                let i = 0;
                for await (let datum of stream) {
                    if (predicate(datum, i++))
                        return datum;
                }
                return undefined;
            })();
        }
        let i = 0;
        for (let datum of data) {
            if (predicate(datum, i++))
                return datum;
        }
        return undefined;
    };
}
