import { isAsyncIterable } from './utils/iterator.js';
export function findIndex(predicate) {
    return function findIndexFn(data) {
        if (isAsyncIterable(data) || data instanceof Promise) {
            return (async () => {
                let stream = data instanceof Promise ? await data : data;
                let i = 0;
                for await (let datum of stream) {
                    if (predicate(datum, i))
                        return i;
                    i++;
                }
                return -1;
            })();
        }
        let i = 0;
        for (let datum of data) {
            if (predicate(datum, i))
                return i;
            i++;
        }
        return -1;
    };
}
