import { isAsyncIterable } from './utils/iterator.js';
export function groupBy(keySelector) {
    return function groupByFn(data) {
        if (isAsyncIterable(data) || data instanceof Promise) {
            return (async () => {
                let stream = data instanceof Promise ? await data : data;
                let map = {};
                let i = 0;
                for await (let datum of stream) {
                    let key = keySelector(datum, i++);
                    if (map[key] === undefined)
                        map[key] = [];
                    map[key].push(datum);
                }
                return map;
            })();
        }
        let map = {};
        let i = 0;
        for (let datum of data) {
            let key = keySelector(datum, i++);
            if (map[key] === undefined)
                map[key] = [];
            map[key].push(datum);
        }
        return map;
    };
}
