import { isAsyncIterable } from './utils/iterator.js';
export function partition(predicate) {
    return function partitionFn(data) {
        if (data == null)
            return;
        if (isAsyncIterable(data) || data instanceof Promise) {
            return (async () => {
                let stream = data instanceof Promise ? await data : data;
                let a = [];
                let b = [];
                let i = 0;
                for await (let datum of stream) {
                    if (predicate(datum, i++)) {
                        a.push(datum);
                    }
                    else {
                        b.push(datum);
                    }
                }
                return [a, b];
            })();
        }
        let a = [];
        let b = [];
        let i = 0;
        for (let datum of data) {
            if (predicate(datum, i++)) {
                a.push(datum);
            }
            else {
                b.push(datum);
            }
        }
        return [a, b];
    };
}
