import { isAsyncIterable } from './utils/iterator.js';
export function some(predicate) {
    return function someFn(data) {
        if (isAsyncIterable(data) || data instanceof Promise) {
            return (async () => {
                let stream = data instanceof Promise ? await data : data;
                let i = 0;
                for await (let datum of stream) {
                    if (predicate(datum, i++))
                        return true;
                }
                return false;
            })();
        }
        let i = 0;
        for (let datum of data) {
            if (predicate(datum, i++))
                return true;
        }
        return false;
    };
}
