import { isAsyncIterable } from './utils/iterator.js';
export function takeWhile(fn) {
    return function takeWhileFn(data) {
        if (isAsyncIterable(data) || data instanceof Promise) {
            return {
                async *[Symbol.asyncIterator]() {
                    let stream = data instanceof Promise ? await data : data;
                    let i = 0;
                    for await (let datum of stream) {
                        if (!fn(datum, i++))
                            return;
                        yield datum;
                    }
                },
            };
        }
        return {
            *[Symbol.iterator]() {
                let i = 0;
                for (let datum of data) {
                    if (!fn(datum, i++))
                        return;
                    yield datum;
                }
            },
        };
    };
}
